/*******************************************************************
 * This is a demonstration of the use of a function template.
 *******************************************************************/

#include<iostream>
#include<string>
#include<vector>
#include<string>
using namespace std;
	
template <class T>
void show(const vector<T>& v);

/* The main function gets a vector of floats and a vector of strings.
 * It uses the same function template, 'show', to display both types 
 * of vector.
 */
int main()
{
	float x;
	string word;
	vector<float> nums;
	vector<string> words;
	cout<<"Please enter some floating point values. "<<
		"Enter 's' to stop. ";
	while(cin>>x)
		nums.push_back(x);
	cin.clear();
	cin>>word;//Get the stop word to discard.
	cout<<"\nPlease enter some words. <Enter> <CTRL>-D. to stop: ";
	while(cin>>word)
		words.push_back(word);
	cout<<endl<<"You entered the following numbers:\n";
	show(nums);
	cout<<endl<<endl<<"You entered the following words:\n";
	show(words);
	return 0;
}

/* In the implementation of 'show', basically use 'T' as a type.
 * Note that the compiler will not recognize vector<T> as a type
 * by default. You must assert that it is a type, using typename.
 */
template <class T>
void show(const vector<T>& v)
{
	typedef typename vector<T>::size_type v_size;
	for(v_size i=0; i<v.size(); i++)
		cout<<v[i]<<" ";
}
